;;;; run.scm


(use heap-o-rama srfi-18)

(set-gc-report! #t)

(define foo
  (##sys#make-structure 'foo (##sys#make-structure 'foo)))

(define (eat)
  (let loop ((n 0) (i 0))
    (unless (>= i 10)
      (thread-sleep! 1)
      (let ((m (* 1000 (random 1000))))
	(print (+ m n))
	(make-vector m)
	(when (gc-happened?)
	  (let-values (((ot ct n) 
			(do-the-dance
			 10
			 (vector 
			  (##sys#make-structure 'foo)
			  (current-thread)
			  (current-time)))))
	    (pp ot)
	    (pp ct)))
	(loop (+ n m) (add1 i))))))
		      
(define (run)
  (setup-low-level-stuff 0 100)
  (eat))

(run)

(##sys#dump-heap-state)
